%global git_commit_sha d993588263fea738df5533ec74111a98c707260f

Name:           ghostty
Version:        1.1.4
Release:        %{?git_commit_sha:0.2.git%(echo %{git_commit_sha} | cut -c -7)}%{!?git_commit_sha:1}%{?dist}
Summary:        Fast, feature-rich, and cross-platform terminal emulator that uses platform-native UI and GPU acceleration


License:        MIT
URL:            https://github.com/ghostty-org/ghostty
Source0:        https://github.com/ghostty-org/ghostty/archive/%{git_commit_sha}.tar.gz
Patch0:         0001-DO-NOT-disable-vulkan-and-gles-for-GTK-4.16.5.patch

ExclusiveArch: x86_64 aarch64


BuildRequires: zig >= 0.14.0
BuildRequires: patchelf
BuildRequires: blueprint-compiler
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
BuildRequires: glib2-devel
BuildRequires: gtk4-devel
BuildRequires: gtk4-layer-shell-devel
BuildRequires: harfbuzz-devel
BuildRequires: libadwaita-devel
BuildRequires: libpng-devel
BuildRequires: oniguruma-devel
BuildRequires: pandoc-cli
BuildRequires: pixman-devel
BuildRequires: pkg-config
BuildRequires: wayland-protocols-devel
BuildRequires: zlib-ng-devel


Requires: fontconfig
Requires: freetype
Requires: glib2
Requires: gtk4
Requires: harfbuzz
Requires: libadwaita
Requires: libpng
Requires: oniguruma
Requires: pixman
Requires: zlib-ng


%description
%{summary}.


%prep
%autosetup -p1 -n ghostty-%{git_commit_sha}


%build
#ZIG_GLOBAL_CACHE_DIR=/tmp/offline-cache ./nix/build-support/fetch-zig-cache.sh
#--system "/tmp/offline-cache/p" \

mkdir -p /tmp/offline-cache/build
export ZIG_GLOBAL_CACHE_DIR=/tmp/offline-cache
export ZIG_LOCAL_CACHE_DIR=/tmp/offline-cache/build
zig build \
    --summary all \
    --prefix "%{buildroot}%{_prefix}" \
    -Dversion-string=%{version}-%{release} \
    -Doptimize=ReleaseFast \
    -Dcpu=baseline \
    -Dpie=true \
    -Demit-docs

# List all the files
find "%{buildroot}" -type f | \
sed 's|^%{buildroot}||'     | \
grep -v '^%{_datadir}/ghostty/' > files.list

patchelf --replace-needed libgtk4-layer-shell.so libgtk4-layer-shell.so.0 %{buildroot}%{_bindir}/ghostty
patchelf --remove-rpath %{buildroot}%{_bindir}/ghostty

%clean
rm -rf /tmp/offline-cache/build

%files -f files.list
%license LICENSE
%{_datadir}/ghostty
#{_bindir}/ghostty
#{_datadir}/applications/com.mitchellh.ghostty.desktop
#{_datadir}/bash-completion/completions/ghostty.bash
#{_datadir}/bat/syntaxes/ghostty.sublime-syntax
#{_datadir}/fish/vendor_completions.d/ghostty.fish
#{_datadir}/icons/hicolor/1024x1024/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/128x128/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/128x128@2/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/16x16/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/16x16@2/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/256x256/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/256x256@2/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/32x32/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/32x32@2/apps/com.mitchellh.ghostty.png
#{_datadir}/icons/hicolor/512x512/apps/com.mitchellh.ghostty.png
#{_datadir}/kio/servicemenus/com.mitchellh.ghostty.desktop
#{_datadir}/nautilus-python/extensions/com.mitchellh.ghostty.py
#{_datadir}/nvim/site/compiler/ghostty.vim
#{_datadir}/nvim/site/ftdetect/ghostty.vim
#{_datadir}/nvim/site/ftplugin/ghostty.vim
#{_datadir}/nvim/site/syntax/ghostty.vim
#{_datadir}/terminfo/g/ghostty
#{_datadir}/terminfo/ghostty.termcap
#{_datadir}/terminfo/ghostty.terminfo
#{_datadir}/terminfo/x/xterm-ghostty
#{_datadir}/vim/vimfiles/compiler/ghostty.vim
#{_datadir}/vim/vimfiles/ftdetect/ghostty.vim
#{_datadir}/vim/vimfiles/ftplugin/ghostty.vim
#{_datadir}/vim/vimfiles/syntax/ghostty.vim
#{_datadir}/zsh/site-functions/_ghostty
#{_mandir}/man1/ghostty.1
#{_mandir}/man5/ghostty.5

%changelog
* Tue Jun 03 2025 Tomas Chang <changyp6@gmail.com> - 1.1.4-0.2
- Update to latest git d993588

* Tue Apr 01 2025 Tomas Chang <changyp6@gmail.com> - 1.1.4
- Update to latest git 1067cd3

* Wed Mar 12 2025 Tomas Chang <changyp6@gmail.com> - 1.1.2
- DO NOT disable gles and vulkan for gtk 4.16.5

* Tue Mar 11 2025 Tomas Chang <changyp6@gmail.com> - 1.1.2
- Update to latest git on date 20250310, with hash 95daca6

* Thu Feb 13 2025 Tomas Chang <changyp6@gmail.com> - 1.1.1
- Update to latest git on date 20250213, with hash 432beac

* Tue Feb 11 2025 Tomas Chang <changyp6@gmail.com> - 1.1.1
- Update to latest git on date 20250210, with hash a3e462b

* Tue Jan 14 2025 Tomas Chang <changyp6@gmail.com> - 1.0.1
- Update to latest git on date 20250114, with hash d1fd22a

* Fri Jan 10 2025 Tomas Chang <changyp6@gmail.com> - 1.0.1
- Initial build
